=== debian/control ===
Source: uclibc
Section: libs
Priority: required
Maintainer: Erik Andersen <andersen@codepoet.org>
Build-Depends: make (>= 3.78-4), dpkg-dev (>= 1.4.1.5), debianutils (>= 1.13.1), tar (>= 1.13.11), bzip2, texinfo (>= 4.0), kernel-source-2.4.22, sed (>= 4.0.5-4)
Standards-Version: 3.5.8

Package: uclibc
Architecture: alpha arm i386 m68k mips mipsel powerpc sparc sh3 sh4 sh3eb sh4eb
Section: base
Priority: required
Depends:
Conflicts: libc6
Description: The uClibc C Library: Shared libraries
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.  This package provides only the run-time libraries.

Package: uclibc-dev
Architecture: alpha arm i386 m68k mips mipsel powerpc sparc sh3 sh4 sh3eb sh4eb
Section: devel
Priority: standard
Depends: uclibc (= ${Source-Version})
Provides: libc-dev, libc6-dev
Recommends: c-compiler
Description: The uClibc C Library: Development Libraries and Header Files
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.  This package includes header files and development
 libraries necessary to compile applications that use uClibc.
